	include	"DoorsOS.h"
	xdef	_main
	xdef	_comment
	xdef	_ti92plus
       xdef   _ti89

;-------------------------------------------------------------
; Program : SysFolds v1.0 beta
;      By : Rafael H. Padilla V.
;  e-mail : dysup@coah1.telmex.net.mx
;
;    Date : 21/03/99
; Description : return in a list all the foldes names
;
; (Program made with : Fargo Program Editor v2.0 )
; ( by: Benoit SCHERRER - p.c.scherrer@wanadoo.fr )
; 
;-------------------------------------------------------------

;***************** Start of FARGO II Program ******************
_main:

       move.w      #$08,d0
       DEREF       d0,a2
       lea         2(A2),a2
       move.w      (a2)+,d3

       tst.w       d3
       beq         _error

  ; ---- Get temporaly mem ----- 
       movem.l     A2/D3,-(A7)
       move.w      d3,d4
       mulu.w      #11,d4
       addq.w      #4,d4

       move.l    d4,-(A7)
       jsr       doorsos::HeapAlloc
       lea       4(A7),A7
       tst.w     D0
       beq       _quit       
       move.w    D0,mem_handle
       DEREF     D0,A0
       move.l    A0,mem_addr       
       movem.l     (A7)+,A2/D3
   ; ----- number of folders -----
       move.w      d3,d4
       mulu        #14,d4
       lea         -14(a2,d4),a2

       subq.w      #1,d3
   ; ---- Init vars -------------
       move.w      #$00,pos
       move.b      #00,d0
       bsr         PushToken
       move.b      #00,d0
       bsr         PushToken

       move.b      #$E5,d0
       bsr         PushToken
\Loop:
       lea         File(pc),a3
       move.l      (a2)+,(a3)
       move.l      (a2),4(a3)
       cmpi.b      #'9',(a3)
       bls         \_NextFold

       moveq.b     #0,d0
       bsr         PushToken

\_StrLoop:
       move.b      (a3)+,d0
       bsr         PushToken
       tst.b       -1(a3)
       bne         \_StrLoop
       moveq.b     #$2D,d0
       bsr         PushToken

\_NextFold:       
       lea         -18(a2),a2
       dbra        d3,\Loop
       move.b      #$D9,d0
       bsr         PushToken       

       move.l      mem_addr,A1
       move.w      pos,D0
       lea         -1(A1,D0),A3

       move.l      A3,doorsos::ReturnValue
    ;   bsr         _END
       bra         _exit

;------------------------------------------------------

_END:
    ; --- Free the memory ----
       move.w    mem_handle,-(A7)
       jsr       doorsos::HeapFree
       lea       2(A7),A7
	rts

_quit:
    ; --- returns empry list
       move.w   #00,pos
       lea      1+emprylist(PC),A3
       move.l   A3,doorsos::ReturnValue
       rts

_error:
       bsr      _END   ;free memory
       bsr      _quit  ;return null list
       bra      _exit  ;stop assembler program

_exit:
       rts

PushToken:
       movem.l     A1/D1,-(A7)
       move.w      pos,D1
       move.l      mem_addr,A1
       lea         0(A1,D1),A1
       move.b      D0,(A1)
       addq.w      #$01,pos
       movem.l     (A7)+,A1/D1
       rts

;******************** Program Variables ***********************
                 EVEN

mem_addr      dc.l  $00000000
mem_handle    dc.w  $0000
pos           dc.w  $0000
emprylist     dc.b  $E5,$D9,0,0
File          dc.b  0,0,0,0,0,0,0,0,0,0,0,0
_comment	dc.b	"sysfolds",0

;********************** End of Program ************************
	end
